#!/usr/local/bin/python2.7

from flask import Flask, abort, request, redirect, send_file, make_response, render_template

from flask.ext.restful import reqparse, abort, Api, Resource
from flask_restful_swagger import swagger
from flask.ext.httpauth import HTTPDigestAuth, HTTPBasicAuth
import pandas as pd

auth = HTTPBasicAuth()

@auth.verify_password
def verify_password(username, password):
	try:
		from SPARQLWrapper import SPARQLWrapper, DIGEST
		sparql = SPARQLWrapper("http://carre.kmi.open.ac.uk:8890/sparql-auth")
		sql = "SELECT ?subject ?predicate ?object FROM <http://carre.kmi.open.ac.uk/users/" + username + "> WHERE { ?subject ?predicate ?object } limit 1"
		sparql.setHTTPAuth(DIGEST)
		sparql.setCredentials(username, password)
		sparql.setQuery(sql)
		results = sparql.query().convert()
		return True
	except Exception, e:
		return False
	return True


app = Flask(__name__)
app.config['SECRET_KEY'] = 'asassffssdfdfs'

api = swagger.docs(Api(app), apiVersion='0.1')

@app.route('/')
@auth.login_required
def index():
	return render_template('index.html')


@app.route('/sparql', methods=['POST', 'GET'])
@auth.login_required
def sparql():
	try:
		q = request.args.get('q', '')
		username = auth.username#request.args.get('username', '')
		password = auth.get_password()# auth.password#request.args.get('password', '')
		format = request.args.get('format', 'JSON')
		from SPARQLWrapper import SPARQLWrapper, DIGEST, JSON, XML, TURTLE, N3, RDF
		import json

		sparql = SPARQLWrapper("http://carre.kmi.open.ac.uk:8890/sparql-auth")
		sparql.setHTTPAuth(DIGEST)
		sparql.setCredentials(username, password)

		sparql.setQuery(q)
		if format.lower()=='json':
			sparql.setReturnFormat(JSON)
		elif format.lower()=='turtle':
			sparql.setReturnFormat(TURTLE)
		elif format.lower()=='xml':
			sparql.setReturnFormat(XML)
		elif format.lower()=='n3':
			sparql.setReturnFormat(N3)
		else:
			return "invalid format. Select one of the following: JSON, XML, TURTLE, N3, RDF"
		results = sparql.query().convert()
		
		# df = pd.DataFrame.from_dict(results['results']['bindings'])
	except Exception, e:
		return str(e)
	if format.lower()=='json':
		return json.dumps(results['results']['bindings'])#df.to_json()
	elif format.lower()=='turtle':
		return results
	elif format.lower()=='xml':
		return results.toxml()
	elif format.lower()=='n3':
		return results

if __name__ == '__main__':
	app.debug = True
	app.run(debug=True, port=65010)
