def getPUBMEDByID(id):
	import requests
	import xmltodict
	response = requests.get("http://eutils.ncbi.nlm.nih.gov/entrez/eutils/esummary.fcgi?db=pubmed&id=" + str(id))
	xml = response.content

	od = xmltodict.parse(xml, process_namespaces=True)
	items = od['eSummaryResult']['DocSum']['Item']

	d = {}
	for item in items:
		if 'Item' in item.keys():
			if isinstance(item['Item'], list):
				subitems = item['Item']
				for subitem in subitems:
					if item['@Name'] in d.keys():
						d[item['@Name']] = d[item['@Name']] + ", " + subitem['#text']
					else:
						d[item['@Name']] = subitem['#text']
			else:
				continue
		else:
			if '#text' in item.keys():
				d[item['@Name']] = item['#text']

	return d
